/*
Copyright (c) 2018-2019 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import * as React from 'react';
import extend from 'just-extend';
import en_US from './en_US.js';
export var LocaleContext = React.createContext(en_US);

var LocaleProvider = function LocaleProvider(props) {
  var locale = props.locale,
      children = props.children;
  return React.createElement(LocaleContext.Provider, {
    value: extend({}, en_US, locale)
  }, children);
};

export default LocaleProvider;